function [S] = get_class_similarity_emd(modtypes, lambda)

  if ~exist('lambda', 'var')
    lambda = 0.2;
  end

  if contains(pwd, '/network/rit/')
    DIRPATH = '/network/rit/lab/zhelevalab/wei_backup';
  else
    DIRPATH = '~/Dropbox';
  end

  FIN = sprintf('%s/zsl-costa-dump2/emd_similarity_snr%d.mat',DIRPATH,20);

  T = load(FIN);
  Smat = T.('dd');
  Smat = exp(-lambda * Smat); % 777

  for i = 1:numel(modtypes)
    i2 = getClassIdx(T.('modkeys'), modtypes{i});
    for j = 1:numel(modtypes)
      j2 = getClassIdx(T.('modkeys'), modtypes{j});
      S(i,j) = Smat(i2,j2);
    end
  end

end


function [idx] = getClassIdx(modkeys,modname)
  if iscell(modname)
    modname = modname{1};
  end
  idx = 0;
  for i = 1:numel(modkeys)
    m = modkeys{i};
    if iscell(m)
      m = m{1};
    end
    if strcmp(m, modname)
      idx = i;
      break
    end
  end
  assert(idx > 0, sprintf('can not find %s in pre-computed similarity matrix', modname))
end