function X = extract_HOC(sigmat)

assert(ndims(sigmat)==2)

x = zeros(size(sigmat, 1),14);

for idx = 1:1:size(sigmat, 1)

  IQdata = sigmat(idx,:);
  IQdata = normalize_signals(IQdata);
  [C20,C21,C40,C41,C42,C60,C61,C62,C63] = Cumulant(IQdata);

  % [lu2017modulation] Modulation Recognition for Incomplete Signals through Dictionary Learning
  F1 = abs(C40)/abs(C42);
  F2 = abs(C42)/(abs(C21)^2);

  % [nie2017automatic] Automatic Modulation Classification Based Multiple Cumulants and Quasi-Newton Method for MIMO System
  % F1 = abs(C2i)^2/abs(C42);  % i in [0,1]
  % F2 = abs(C4i)/abs(C42);  % i in [0,1]
  % F3 = abs(C2i)^3/abs(C63);  % i in [0,1]
  % F4 = abs(C4i)^3/abs(C63);  % i in [0,1,2]

  F1 = abs(C40)/abs(C42);
  F2 = abs(C41)/abs(C42);
  F3 = abs(C40)/abs(C63);
  F4 = abs(C41)/abs(C63);
  F5 = abs(C42)/abs(C63);

  x(idx,:) = [abs(C20),abs(C21),abs(C40),abs(C41),abs(C42),abs(C60),abs(C61),abs(C62),abs(C63), F1,F2,F3,F4,F5];
end

X = x;

% % split complex columns into real + imag columns
% count = 0;
% % fprintf('C20 %d\n', isreal(x(:,1)))
% count = count + 1-isreal(x(:,1));
% % fprintf('C21 %d\n', isreal(x(:,2)))
% count = count + 1-isreal(x(:,2));
% % fprintf('C40 %d\n', isreal(x(:,3)))
% count = count + 1-isreal(x(:,3));
% % fprintf('C41 %d\n', isreal(x(:,4)))
% count = count + 1-isreal(x(:,4));
% % fprintf('C42 %d\n', isreal(x(:,5)))
% count = count + 1-isreal(x(:,5));
% % fprintf('C60 %d\n', isreal(x(:,6)))
% count = count + 1-isreal(x(:,6));
% % fprintf('C61 %d\n', isreal(x(:,7)))
% count = count + 1-isreal(x(:,7));
% % fprintf('C62 %d\n', isreal(x(:,8)))
% count = count + 1-isreal(x(:,8));
% % fprintf('C63 %d\n', isreal(x(:,9)))
% count = count + 1-isreal(x(:,9));

% % split complex column into real + imag columns

% X = zeros(size(x,1),size(x,2)+count);
% cc = 0;
% for i = 1:size(x,2)
%   if isreal(x(:,i))
%     X(:,i) = x(:,i);
%   else
%     cc = cc + 1;
%     idx = size(x,2) + cc;
%     X(:,idx) = imag(x(:,i));
%     X(:,i) = real(x(:,i));
%   end
% end
% assert (cc == count)