function [x, y, idx] = reduce_dataset_to_num(x, y, num, shuffle)

if ~exist('shuffle', 'var')
  shuffle = 0;
end

assert(num <= size(y,1))
assert(size(x,1) == size(y,1))

if num < size(y,1)
  [train,test] = crossvalind('HoldOut',y, num/size(y,1));
  assert(sum(double(test))>0) % in case num/size(y,1) under-overflow
  x = x(test,:);y = y(test,:);

elseif num == size(y,1)
  x = x; y = y;  test = 1:size(y,1);

else
  assert(false);
end

if shuffle
  idx = randperm(size(x,1));
  x = x(idx,:);
  y = y(idx,:);
else
  idx = test;
end